#! /usr/bin/env python
# -*- coding: utf_8 -*-
from pandac.PandaModules import *
from direct.directbase import DirectStart

class MyClient:
    def __init__(self, host, port, timeout=3000):
        self.host = host
        self.port = port
        self.timeout = timeout
        self.cManager = QueuedConnectionManager()
        self.cReader = QueuedConnectionReader(self.cManager, 0)
        self.cReader.setRawMode(True)
        self.cWriter = ConnectionWriter(self.cManager,0)
        self.cWriter.setRawMode(True)
        self.connected = False
        self.connect(self.host, self.port, self.timeout)
        taskMgr.add(self.disconnectTask, "clientDisconnectTask", -39)
        taskMgr.add(self.readTask, "clientReadTask", -38)
    def connect(self, host, port, timeout=3000):
        self.myConnection = self.cManager.openTCPClientConnection(host, port, timeout)
        if self.myConnection:
            self.cReader.addConnection(self.myConnection)
            self.connected = True
            self.cWriter.send('Hello, Server!',self.myConnection)
    def readTask(self, task):
        while self.cReader.dataAvailable():
            datagram = NetDatagram()
            if self.cReader.getData(datagram):
                msg = datagram.getMessage()
                conn = datagram.getConnection()
                print msg
        return task.cont
    def disconnectTask(self, task):
        while self.cManager.resetConnectionAvailable() == True:
            connPointer = PointerToConnection()
            self.cManager.getResetConnection(connPointer)
            connection = connPointer.p()
            self.cReader.removeConnection(connection)
            self.connected = False
            print "Reset connection."
        return task.cont
clnt = MyClient("127.0.0.1", 9099)
run()